// FILENAME:	SS_WAR_ZONE.cs
//
// AUTHORS:  	Warhawk UF [SGT] & Static 69 UF [SGT]
// AUTHOR OF REMAPING: TAT
//------------------------------------------------------------------------------

$missionName = "SS_WAR_ZONE";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
//exec("vanilla.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function player::onAdd(%this)
{
   player::onAddLog(%this);
        
        if($server::TeamPlay == false)
        {
      say(%this,0, "Hiya");           
   }
        else
        {
      say(%this,0, "Welcome");
   }
} 

$teamHittingPenalty = True;

function onMissionStart()
{
	$healRate = 0;   
	$ammoRate = 0;
   	$padWaitTime = 0;
  	$zenWaitTime = 0;

// Keep tracks of hercs near a door
	$HercsAtDoor1 = 0;
	$HercsAtDoor2 = 0;
      $HercsAtDoor3 = 0;
	$HercsAtDoor4 = 0;

	marsSounds();
}


function onMissionLoad(){
   cdAudioCycle("Purge", "Terror", "Watching"); 
// custom rules for this mission ( teleporter )
   %rules = "<tIDMULT_TDM_GAMETYPE>"   @        
            "<tIDMULT_TDM_MAPNAME>"    @ 
            $missionName               @
            "<tIDMULT_TDM_OBJECTIVES>" @
            "<tIDMULT_TDM_SCORING_1>"  @
            "<tIDMULT_TDM_SCORING_2>"  @
            $killPoints                @
            "<tIDMULT_TDM_SCORING_3>"  @
            "<tIDMULT_TDM_SCORING_4>"  @
            $deathPoints               @
            "<tIDMULT_TDM_SCORING_5>"  @
            "<tIDMULT_TDM_SCORING_6>"  @
            "<tIDMULT_STD_ITEMS>"      @
            "<tIDMULT_STD_TELEPORTER>" @
            "<tIDMULT_STD_HEAL>"       @
            "<tIDMULT_STD_RELOAD>";

   setGameInfo(%rules);
}

function setDefaultMissionItems() 
{
   allowVehicle("all", true);
   allowComponent("all", true);
   allowWeapon("all", true);
}

function Trigger1::trigger::onContact(%this, %object)
{
	
	setPosition(%object, -188, 6.7, 1198);
}
function Trigger2::trigger::onContact(%this, %object)
{
	
	setPosition(%object, 150, -557, 535);
}

function Trigger3::trigger::onContact(%this, %object)
{
	
	setPosition(%object, 110, 153, 805);
}
function Trigger4::trigger::onContact(%this, %object)
{
	
	setPosition(%object, 117, 47, 580);
}
function Trigger5::trigger::onContact(%this, %object)
{
	
	setPosition(%object, 85, -522, 520);
}
function Trigger6::trigger::onContact(%this, %object)
{
	
	setPosition(%object, 10, -419, 730);
}
function Triggersnowman::trigger::onContact(%this, %object)
{
	
	setPosition(%object, 279, 29, 3500);
}

function Ball1::trigger::onContact(%this, %object)
{
	
	setPosition(%object, 202, 1500, 530);
}

function Ball2::trigger::onContact(%this, %object)
{
	
	setPosition(%object, 1354, -675, 730);
}

function ball5::trigger::onContact(%this, %object)
{
	
	setPosition(%object, -24, -345, 552);
}

function ball6::trigger::onContact(%this, %object)
{
	
	setPosition(%object, 241, 28, 552);
}

function ball7::trigger::onContact(%this, %object)
{
	
	setPosition(%object, 269, -352, 752);
}

function ball8::trigger::onContact(%this, %object)
{
	
	setPosition(%object, -14, 28, 752);
}

function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}

function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}

function door2::trigger::onEnter(%this, %vehicleId){
	if($hercsAtdoor2 == 0){
		playAnimSequence(getObjectId("MissionGroup\\stuff\\door2"), 0, true);
	}
	$hercsAtdoor2 = $hercsAtdoor2 + 1;
}
function door2::trigger::onLeave(%this, %vehicleId){
	$hercsAtdoor2 = $hercsAtdoor2 - 1;
	if($hercsAtdoor2 == 0){
		playAnimSequence(getObjectId("MissionGroup\\stuff\\door2"), 0, false);
	}
}

function door3::trigger::onEnter(%this, %vehicleId){
	if($hercsAtdoor3 == 0){
		playAnimSequence(getObjectId("MissionGroup\\stuff\\door3"), 0, true);
	}
	$hercsAtdoor3 = $hercsAtdoor3 + 1;
}
function door3::trigger::onLeave(%this, %vehicleId){
	$hercsAtdoor3 = $hercsAtdoor3 - 1;
	if($hercsAtdoor3 == 0){
		playAnimSequence(getObjectId("MissionGroup\\stuff\\door3"), 0, false);
	}
}

