// WAR, war, what is it good for? -- TSL

$missionName = "WAR City on the Edge";

exec("multiplayerStdLib.cs");

$enemyDropped = false;

///////////////////////////////////////////////////////////////////////////////////////////////////
// Lots O' Globals
///////////////////////////////////////////////////////////////////////////////////////////////////
$redKills = 0;
$yellowKills = 0;

$redBuildingsDestroyed = 0;
$yellowBuildingsDestroyed = 0;

$yellowHerc1RespawnTime = 0;
$yellowHerc2RespawnTime = 0;
$yellowHerc3RespawnTime = 0;
$redHerc1RespawnTime = 0;
$redHerc2RespawnTime = 0;
$redHerc3RespawnTime = 0;

$yellowHerc1Path = "MissionGroup/yellowHerc1Path";
$yellowHerc2Path = "MissionGroup/yellowHerc2Path";
$yellowHerc3Path = "MissionGroup/yellowHerc3Path";
$redHerc1Path = "MissionGroup/redHerc1Path";
$redHerc2Path = "MissionGroup/redHerc2Path";
$redHerc3Path = "MissionGroup/redHerc3Path";


$yellowHqDestroyed = false;
$redHqDestroyed = false;

///////////////////////////////////////////////////////////////////////////////////////////////////
// the Game Info tab uses these variables in the rules
///////////////////////////////////////////////////////////////////////////////////////////////////
$respawnDelay = 60;
$respawnDelayNoHq = 120;
$BUILDINGS_TO_DESTROY = 6;

///////////////////////////////////////////////////////////////////////////////////////////////////
// our base defender attributes
//
// The jump from 0.9 to 1.0 is a big one. At skill 1.0 and accuracy 1.0 the AI units will aim 
// first for the weapons, then the legs. A little too much for this mission.
//
///////////////////////////////////////////////////////////////////////////////////////////////////
Pilot YellowPilot
{
   id = 28;
   name = *IDMULT_WAR_YELLOW_DEFENDER;
   skill = 1.0;
   accuracy = 0.9;
   aggressiveness = 2.0;
   activateDist = 850.0;
   deactivateBuff = 300.0;
   targetFreq = 2.0;
   trackFreq = 0.2;
   fireFreq = 0.2;
   LOSFreq = 0.1;
   orderFreq = 2.0;
};

Pilot RedPilot
{
   id = 29;   
   name = *IDMULT_WAR_RED_DEFENDER;
   skill = 1.0;
   accuracy = 0.9;
   aggressiveness = 2.0;
   activateDist = 850.0;
   deactivateBuff = 300.0;
   targetFreq = 2.0;
   trackFreq = 0.1;
   fireFreq = 0.2;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};


function initGlobalVars()
{
   $scoringFreeze = false;
   
   %playerCount = playerManager::getPlayerCount();
	// clear all points for the players
   for (%p = 0; %p < %playerCount; %p++)
	{
      %player = playerManager::getPlayerNum(%p);
      %player.numKills = 0;
      %player.buildingsDestroyed = 0;
   }
}

function setDefaultMissionOptions()
{
	$server::TeamPlay = True;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = True;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = false;

   $server::disableTeamRed = false;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = true;
}

function setDefaultMissionItems()
{
   allowWeapon(    150,FALSE); //SMARTGun

}

function onMissionLoad()
{

  $aiMade = false;


  deleteObject( "MissionGroup/yellowHercs/h1" );
  deleteObject( "MissionGroup/yellowHercs/h2" );
  deleteObject( "MissionGroup/yellowHercs/h3" );
  deleteObject( "MissionGroup/redHercs/h1" );
  deleteObject( "MissionGroup/redHercs/h2" );
  deleteObject( "MissionGroup/redHercs/h3" );


   cdAudioCycle("Purge", "Watching", "Mechsoul"); 

   // get the original ID for each AI Herc ( for use later when we clone them )
//   $yellowHerc1 = getObjectId( "MissionGroup/yellowHercs/h1" );
//   $yellowHerc2 = getObjectId( "MissionGroup/yellowHercs/h2" );
//   $yellowHerc3 = getObjectId( "MissionGroup/yellowHercs/h3" );

//   $redHerc1 = getObjectId( "MissionGroup/redHercs/h1" );
//   $redHerc2 = getObjectId( "MissionGroup/redHercs/h2" );
//   $redHerc3 = getObjectId( "MissionGroup/redHercs/h3" );


   $redReload = getObjectId( "MissionGroup/redHercs/reloadPath/redReload" );

   $yellowHeal = getObjectId( "MissionGroup/yellowHercs/healPath/yellowHeal" );
   $yellowReload = getObjectId( "MissionGroup/yellowHercs/reloadPath/yellowReload" );



   %rules = "<tIDMULT_WAR_GAMETYPE>"      @        
            "<tIDMULT_WAR_MAPNAME>"       @ 
            $missionName                  @
"\n\nUse the teleporters to quickly get from your base to the enemy base.\n\n" @
"The defending AI are randomly picked from the players.\n\n" @
"The regular WAR rules apply.";

   
   setGameInfo(%rules);
}


//-------------------------------------------------------------
function player::onAdd(%this)
{
   say(%this, 0, *IDMULT_WAR_WELCOME);
}

function vehicle::onAdd(%this)
{
   // see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
      return;

   schedule( "setEnemyNavPoint(" @ %this @ ");", 1 );

  if ( $aiMade == false )
   {
     $aiMade = true;
     schedule ("makeAIguards();", 45);
   }
}

function setEnemyNavPoint( %this )
{
   if( getTeam(%this) == *IDSTR_TEAM_YELLOW )
   {
      setNavMarker( "MissionGroup/RedBase/NavPoint", true, %this );
   }
   else
   {
      setNavMarker( "MissionGroup/YellowBase/NavPoint", true, %this );
   }
}


function vehicle::onDestroyed( %this, %destroyer )
{
echo ("start of vehicle destroyed");

   if( getTeam( %this ) == *IDSTR_TEAM_RED )
   {
      $yellowKills++;
   }
   else
   {
      $redKills++;
   }

echo ("before award player kill");

   // award the player a kill ( if the enemy is a different color )
   if( getTeam( %destroyer ) != getTeam( %this ) )
   {
      %player = playerManager::vehicleIdToPlayerNum( %destroyer );
      if(%player != 0)
      {
         %player.numKills++;      
      }
   }
echo ("after award player kill");
   
   //----------------------------------------------------------------
   // If any of our AI hercs die, give a message and re-clone/drop them
   //----------------------------------------------------------------
   if( %this == $yellowHerc1 )
   {
      $yellowHercsDestroyed++;
      
      if( $yellowHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc1\", " @ %this @ ", -1415, 561, 170);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc1\", " @ %this @ ",  -1415, 561, 170);", $respawnDelayNoHq);
      }
   }
   if( %this == $yellowHerc2 )
   {
      $yellowHercsDestroyed++;

      if( $yellowHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc2\", " @ %this @ ", -1657, -280, 164);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc2\", " @ %this @ ",  -1657, -280, 164);", $respawnDelayNoHq);
      }
   }
   if( %this == $yellowHerc3 )
   {
      $yellowHercsDestroyed++;
      
      if( $yellowHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc3\", " @ %this @ ", -2072, 766, 185);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc3\", " @ %this @ ", -2072, 766, 185);", $respawnDelayNoHq);
      }
   }

   if( %this == $redHerc1 )
   {
      $redHercsDestroyed++;
      
      if( $redHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$redHerc1\", " @ %this @ ", 1430, -536, 157);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$redHerc1\", " @ %this @ ",  1430, -536, 157);", $respawnDelayNoHq);
      }
   }
   if( %this == $redHerc2 )
   {
      $redHercsDestroyed++;
      
      if( $redHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$redHerc2\", " @ %this @ ", 1476, -1573, 173);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$redHerc2\", " @ %this @ ", 1476, -1573, 173);", $respawnDelayNoHq);
      }
   }
   if( %this == $redHerc3 )
   {
      $redHercsDestroyed++;
      
      if( $redHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$redHerc3\", " @ %this @ ",  1662, -523, 150);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$redHerc3\", " @ %this @ ",  1662, -523, 150);", $respawnDelayNoHq);
      }
   }

   // left over from missionStdLib.cs
//   vehicle::onDestroyedLog(%this, %destroyer);

// give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message);
   }

}

function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

	$ScoreBoard::PlayerColumnHeader1 = "Team";
	$ScoreBoard::PlayerColumnHeader2 = "Kills";
	$ScoreBoard::PlayerColumnHeader3 = "Buildings Destroyed";

	$ScoreBoard::PlayerColumnFunction1 = "getTeam2";
	$ScoreBoard::PlayerColumnFunction2 = "getKills";
	$ScoreBoard::PlayerColumnFunction3 = "getBuildingsDestroyed";

   $ScoreBoard::TeamColumnHeader1 = "Structures Remaining";
   $ScoreBoard::TeamColumnHeader2 = "Total Kills";
   $ScoreBoard::TeamColumnFunction1 = "getRemainingStructures";
   $ScoreBoard::TeamColumnFunction2 = "getTeamKills";
 
   serverInitScoreBoard();
}

function getTeam2(%player)
{
   if( getTeam( %player ) == *IDSTR_TEAM_YELLOW )
   {
      return *IDMULT_YELLOW;
   }
   else
   {
      return *IDMULT_RED;
   }
}

function getKills(%player)
{
   if( %player.numKills != "")
      return %player.numKills;
      
   return "0";
}

function getTeamKills(%team)
{
   if( getTeamNameFromTeamId(%team) == *IDSTR_TEAM_YELLOW )
   {
      return $yellowKills;
   }
   else
   {
      return $redKills;
   }   
}

function getRemainingStructures(%team)
{
   if( getTeamNameFromTeamId(%team) == *IDSTR_TEAM_YELLOW )
   {
      return $BUILDINGS_TO_DESTROY - $yellowBuildingsDestroyed;
   }
   else
   {
      return $BUILDINGS_TO_DESTROY - $redBuildingsDestroyed;
   }   
}

function getBuildingsDestroyed(%player)
{
   if( %player.buildingsDestroyed != "")
      return %player.buildingsDestroyed;
   
   return "0";
}

function redGen1::structure::onDestroyed( %this, %who )
{
  $redBuildingsDestroyed++;
  checkForWin();

  order( "MissionGroup/redBase/t1", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;
  }

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_RED_BR_GEN_DESTROYED;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
}

function redGen2::structure::onDestroyed( %this, %who )
{
  $redBuildingsDestroyed++;
  checkForWin();

  order( "MissionGroup/redBase/t2", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;     
  }

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_RED_FR_GEN_DESTROYED;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
}

function redGen3::structure::onDestroyed( %this, %who )
{
  $redBuildingsDestroyed++;
  checkForWin();
 
  order( "MissionGroup/redBase/t3", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;     
  }

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_RED_CEN_GEN_DESTROYED;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
}

function redGen4::structure::onDestroyed( %this, %who )
{
  $redBuildingsDestroyed++;
  checkForWin();

  order( "MissionGroup/redBase/t4", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;     
  }

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_RED_BL_GEN_DESTROYED;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
}

function redGen5::structure::onDestroyed( %this, %who )
{
  $redBuildingsDestroyed++;
  checkForWin();

  order( "MissionGroup/redBase/t5", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;     
  }

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_RED_FL_GEN_DESTROYED;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
}

function yellowGen1::structure::onDestroyed( %this, %who )
{
  $yellowBuildingsDestroyed++;
  checkForWin();

  order( "MissionGroup/yellowBase/t1", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;     
  }

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_YELLOW_FR_GEN_DESTROYED;
  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    
}

function yellowGen2::structure::onDestroyed( %this, %who )
{
  $yellowBuildingsDestroyed++;
  checkForWin();

  order( "MissionGroup/yellowBase/t2", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;     
  }

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_YELLOW_BR_GEN_DESTROYED;
  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    
}

function yellowGen3::structure::onDestroyed( %this, %who )
{
  $yellowBuildingsDestroyed++;
  checkForWin();

  order( "MissionGroup/yellowBase/t3", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;     
  }

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_YELLOW_CEN_GEN_DESTROYED;
  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    
}

function yellowGen4::structure::onDestroyed( %this, %who )
{
  $yellowBuildingsDestroyed++;
  checkForWin();

  order( "MissionGroup/yellowBase/t4", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;     
  }

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_YELLOW_BL_GEN_DESTROYED;
  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    
}

function yellowGen5::structure::onDestroyed( %this, %who )
{
  $yellowBuildingsDestroyed++;
  checkForWin();

  order( "MissionGroup/yellowBase/t5", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;     
  }

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_YELLOW_BL_GEN_DESTROYED;
  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    
}

function redHQ::structure::onDestroyed( %this, %who )
{
  $redBuildingsDestroyed++;
  checkForWin();
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;     
  }

  $redHqDestroyed = true;

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
  say(0, 1234, "<F5>" @ *IDMULT_WAR_RED_HQ_DESTROYED @ timeDifference($respawnDelayNoHq, 0) @ "." );
}


function yellowHQ::structure::onDestroyed( %this, %who )
{
  $yellowBuildingsDestroyed++;
  checkForWin();
  %player = playerManager::vehicleIdToPlayerNum( %who );
  if(%player != 0)
  {
      %player.buildingsDestroyed++;     
  }
  
  $yellowHqDestroyed = true;

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    

  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    
  say(0, 1234, "<F5>" @ *IDMULT_WAR_YELLOW_HQ_DESTROYED @ timeDifference($respawnDelayNoHq, 0) @ "." );
}


function onMissionStart()
{
	$healRate = 100;   
	$ammoRate = 3;
 	$padWaitTime = 45;

   windSounds();
	marsSounds();	

   initGlobalVars();
   
//   order( $yellowHerc1, guard, $yellowHerc1Path );
//   order( $yellowHerc2, guard, $yellowHerc2Path );
//   order( $yellowHerc3, guard, $yellowHerc3Path );
//   order( $redHerc1, guard, $redHerc1Path );
//   order( $redHerc2, guard, $redHerc2Path );
//   order( $redHerc3, guard, $redHerc3Path );
}

function checkForWin()
{
   if( $yellowBuildingsDestroyed >= $BUILDINGS_TO_DESTROY )
   {
      fadeEvent( 0, out, 1.5, 1.0, 0, 0 ); 
      schedule( "missionEndConditionMet();", 1.6 );
      
      %txt = "Red team wins!";
      messageBox(0, %txt);
   }
   else if( $redBuildingsDestroyed >= $BUILDINGS_TO_DESTROY )
   {
      fadeEvent( 0, out, 1.5, 1.0, 1.0, 0 ); 
      schedule( "missionEndConditionMet();", 1.6 );
      
      %txt = "Yellow team wins!";
      messageBox(0, %txt);
   }   
}


// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}
 
function trevorsCloneVehicle(%globalVarName, %old, %x, %y, %z)
{
   %clone = cloneVehicle(%old);
   setPosition(%clone, %x, %y, %z);

   schedule( "deleteObject(" @ %old @ ");", $respawnDealNoHq + 10 );

   schedule( %globalVarName @ " = " @ %clone @ ";", 0);

   addToSet( "MissionGroup", %clone );

   %path = %globalVarName @ "Path";
   schedule( "order( " @ %clone @ ", guard, " @ %path @ " );", 1 );
}



function YellowTransporter::trigger::onEnter(%this, %vehicleId)
{
  randomTransport( %vehicleId, 220, -365, 618, -265);

}
function YellowTransporter2::trigger::onEnter(%this, %vehicleId)
{
  randomTransport( %vehicleId, 2100, -2050, 2800, -2600);

}

function RedTransporter::trigger::onEnter(%this, %vehicleId)
{
  randomTransport( %vehicleId, -383, 595, 0, 660); //%x1, %y1, %x2, %y2)
}
function RedTransporter2::trigger::onEnter(%this, %vehicleId)
{
//  randomTransport( %vehicleId, 2200, 130, 2900, 930); //%x1, %y1, %x2, %y2)
  randomTransport( %vehicleId, -2473, 800, -3000, 1300); //%x1, %y1, %x2, %y2)
}


function vehicle::onMessage (%this, %message, %_1, %_2, %_3, %_4, %_5, %_6, %_7, %_8, %_9)
{

//say (0,0, "DEBUG: this= "@ %this @ " message = "@ %message @ " _1= "@ %_1 );

   %player = playerManager::vehicleIdToPlayerNum(%this);

   if(%player != 0) 
      return;

  if (getTeam (%this) == *IDSTR_TEAM_RED)
   {
     repairReloadRed(%this);
   }
  else
   {
     repairReloadYellow(%this);
   }

}

function repairReloadRed (%this)
{
  order (%this, guard, $redReload);
}

function repairReloadYellow (%this)
{
  order (%this, guard, $yellowReload);
}

//function AIherc::vehicle::onArrived (%who, %where)
function vehicle::onArrived (%who, %where)
{

//say (0,0, "DEBUG: who = " @ %who @ " where " @ %where );


  if (%where == $redReload )
    {
//say (0,0, "DEBUG: red Zen " );

      schedule ("order (" @ %who @ ", shutdown, true );", 1 );
      schedule ("order (" @ %who @ ", shutdown, false );", 5 );

     if ( %who == $redHerc1 )
      {
       order( %who, guard, $redHerc1Path );
      }

     if ( %who == $redHerc2 )
      {
       order( %who, guard, $redHerc2Path );
      }

     if ( %who == $redHerc3 )
      {
       order( %who, guard, $redHerc3Path );
      }


    }

  if (%where == $yellowReload )
    {

//say (0,0, "DEBUG: Yellow ZEN " );

      schedule ("order (" @ %who @ ", shutdown, true );", 1 );
      schedule ("order (" @ %who @ ", shutdown, false );", 5 );


     if ( %who == $yellowHerc1 )
      {
       order( %who, guard, $yellowHerc1Path );
      }

     if ( %who == $yellowHerc2 )
      {
       order( %who, guard, $yellowHerc2Path );
      }

     if ( %who == $yellowHerc3 )
      {
       order( %who, guard, $yellowHerc3Path );
      }

    }

}


function AIZen::trigger::onEnter(%this, %object)
{
// keep humans from using the fast zen
   %player = playerManager::vehicleIdToPlayerNum(%object);
   if(%player != 0) 
      return;

   	Zen::onEnter(%this, %object, "", true, true);  
}

function AIZen::trigger::onContact(%this, %object)
{
// keep humans from using the fast zen
   %player = playerManager::vehicleIdToPlayerNum(%object);
   if(%player != 0) 
      return;

     Zen::work(%this, %object, 1000, 1000, 0, true); 
}
function makeAIguards()
{

   %playerVeh = pickPlayer ();
 if (%playerVeh > 1000)
   {

   %herc = cloneVehicle(%playerVeh);
   SetPilotId( %herc, 29);
   setTeam (%herc, *IDSTR_TEAM_RED);
   addToSet( "MissionGroup/redHercs", %herc );

  setPOsition (%herc, 1430, -536, 157);

//  order (%herc, Guard, $redHerc1Path );
$redHerc1 = %herc;


   %playerVeh = pickPlayer ();
   %herc = cloneVehicle(%playerVeh);
   SetPilotId( %herc, 29);
   setTeam (%herc, *IDSTR_TEAM_RED);
   addToSet( "MissionGroup/redHercs", %herc );
  setPOsition (%herc, 1476, -1573, 173); //r2
//  order (%herc, Guard, $redHerc2Path );
$redHerc2 = %herc;


   %playerVeh = pickPlayer ();
   %herc = cloneVehicle(%playerVeh);
   SetPilotId( %herc, 29);
   setTeam (%herc, *IDSTR_TEAM_RED);
   addToSet( "MissionGroup/redHercs", %herc );
  setPOsition (%herc, 1662, -523, 150); //r3
//  order (%herc, Guard, $redHerc3Path );
$redHerc3 = %herc;




   %playerVeh = pickPlayer ();
   %herc = cloneVehicle(%playerVeh);
   SetPilotId( %herc, 28);
   setTeam (%herc, *IDSTR_TEAM_YELLOW);
   addToSet( "MissionGroup/yellowHercs", %herc );

  setPOsition (%herc, -1415, 561, 170);

//  order (%herc, Guard, $yellowHerc1Path );

$yellowHerc1 = %herc;

   %playerVeh = pickPlayer ();
   %herc = cloneVehicle(%playerVeh);
   SetPilotId( %herc, 28);
   setTeam (%herc, *IDSTR_TEAM_YELLOW);
   addToSet( "MissionGroup/yellowHercs", %herc );
$yellowHerc2 = %herc;

  setPOsition (%herc, -1657, -280, 164);

//  order (%herc, Guard, $yellowHerc2Path );

   %playerVeh = pickPlayer ();
   %herc = cloneVehicle(%playerVeh);
   SetPilotId( %herc, 28);
   setTeam (%herc, *IDSTR_TEAM_YELLOW);
   addToSet( "MissionGroup/yellowHercs", %herc );
$yellowHerc3 = %herc;

  setPOsition (%herc, -2072, 766, 185);

//  order (%herc, Guard, $yellowHerc3Path );

schedule ("orderguard();", 5);

  }
  else
  {
  schedule ("makeAIguards();", 40);
  }

}


//-----------------------------------------------------------------------------
function pickPlayer ()
{
// do 100 just to make sure we get a player that is in the game
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if ( %playerVeh != "" )
       {
         return %playerVeh;
       }
     }
  return 0;

}

function orderguard()
{
   order( $yellowHerc1, guard, $yellowHerc1Path );
   order( $yellowHerc2, guard, $yellowHerc2Path );
   order( $yellowHerc3, guard, $yellowHerc3Path );
   order( $redHerc1, guard, $redHerc1Path );
   order( $redHerc2, guard, $redHerc2Path );
   order( $redHerc3, guard, $redHerc3Path );
}

